Index: /main/trunk/greenstone3/web/interfaces/oran/js/jquery.themeswitcher.min.js
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/js/jquery.themeswitcher.min.js	(revision 25122)
+++ /main/trunk/greenstone3/web/interfaces/oran/js/jquery.themeswitcher.min.js	(revision 25123)
@@ -1,14 +1,349 @@
-(function(b){b.fn.themeswitcher=function(c){function d(f){a.onselect!==null&&a.onselect();m.text(a.buttonpretext+" "+f.title);var e=b("<link/>").attr("type","text/css").attr("rel","stylesheet");f.url?e.attr("href",f.url):e.attr("href","http://ajax.googleapis.com/ajax/libs/jqueryui/"+a.jqueryuiversion+"/themes/"+f.name+"/jquery-ui.css");e.appendTo("head");b.cookie(a.cookiename,f.name);g.find(".jquery-ui-switcher-title").text(a.buttonpretext+" "+f.title);a.closeonselect&&h()}function j(f){var e=null;
-b.each(l,function(n,i){if(i.name.toLowerCase()===f.toLowerCase()||i.title.toLowerCase()===f.toLowerCase()){e=i;return false}});if(!e)return l[0];return e}function h(){a.onclose!==null&&a.onclose();g.find(".jquery-ui-switcher-list-hldr").slideUp("fast",function(){g.find(".jquery-ui-switcher-link").css({color:"#666",background:"#eee url("+a.imgpath+"buttonbg.png) repeat-x 50% 50%"})})}var g=this,o={},a={loadtheme:"",height:200,width:175,rounded:true,imgpath:"",jqueryuiversion:"1.8.10",initialtext:"Switch Theme",
-buttonpretext:"Theme:",closeonselect:true,buttonheight:14,cookiename:"jquery-ui-theme",themes:[],additionalthemes:[],onopen:null,onclose:null,onselect:null};if(c){b.each(c,function(f,e){o[f.toLowerCase()]=e});b.extend(a,o)}var l=a.themes.length?a.themes:[{title:"Black Tie",name:"black-tie",icon:"theme_90_black_tie.png"},{title:"Blitzer",name:"blitzer",icon:"theme_90_blitzer.png"},{title:"Cupertino",name:"cupertino",icon:"theme_90_cupertino.png"},{title:"Dark Hive",name:"dark-hive",icon:"theme_90_dark_hive.png"},
-{title:"Dot Luv",name:"dot-luv",icon:"theme_90_dot_luv.png"},{title:"Eggplant",name:"eggplant",icon:"theme_90_eggplant.png"},{title:"Excite Bike",name:"excite-bike",icon:"theme_90_excite_bike.png"},{title:"Flick",name:"flick",icon:"theme_90_flick.png"},{title:"Hot Sneaks",name:"hot-sneaks",icon:"theme_90_hot_sneaks.png"},{title:"Humanity",name:"humanity",icon:"theme_90_humanity.png"},{title:"Le Frog",name:"le-frog",icon:"theme_90_le_frog.png"},{title:"Mint Choc",name:"mint-choc",icon:"theme_90_mint_choco.png"},
-{title:"Overcast",name:"overcast",icon:"theme_90_overcast.png"},{title:"Pepper Grinder",name:"pepper-grinder",icon:"theme_90_pepper_grinder.png"},{title:"Redmond",name:"redmond",icon:"theme_90_windoze.png"},{title:"Smoothness",name:"smoothness",icon:"theme_90_smoothness.png"},{title:"South Street",name:"south-street",icon:"theme_90_south_street.png"},{title:"Start",name:"start",icon:"theme_90_start_menu.png"},{title:"Sunny",name:"sunny",icon:"theme_90_sunny.png"},{title:"Swanky Purse",name:"swanky-purse",
-icon:"theme_90_swanky_purse.png"},{title:"Trontastic",name:"trontastic",icon:"theme_90_trontastic.png"},{title:"UI Darkness",name:"ui-darkness",icon:"theme_90_ui_dark.png"},{title:"UI Lightness",name:"ui-lightness",icon:"theme_90_ui_light.png"},{title:"Vader",name:"vader",icon:"theme_90_black_matte.png"}];a.additionalthemes.length&&b.extend(l,a.additionalthemes);c={cursor:"pointer","font-family":"'Trebuchet MS', Verdana, sans-serif","font-size":"11px",color:"#666",background:"#eee url("+a.imgpath+
-"buttonbg.png) repeat-x 50% 50%",border:"1px solid #CCC","text-decoration":"none",padding:"3px 3px 3px 8px",width:a.width+"px",display:"block",height:a.buttonheight+"px",outline:"0px","line-height":a.buttonheight+"px"};if(a.rounded){c["border-radius"]="6px";c["-moz-border-radius"]="6px";c["-webkit-border-radius"]="6px"}c=b("<a/>").addClass("jquery-ui-switcher-link").css(c).bind({mouseenter:function(){b(this).css({background:"#eee"})},mouseleave:function(){g.find(".jquery-ui-switcher-list-hldr").is(":visible")||
-b(this).css({background:"#eee url("+a.imgpath+"buttonbg.png) repeat-x 50% 50%"})},click:function(){if(g.find(".jquery-ui-switcher-list-hldr").is(":visible"))h();else{a.onopen!==null&&a.onopen();g.find(".jquery-ui-switcher-link").css({color:"#AAA",background:"#000"});g.find(".jquery-ui-switcher-list-hldr").slideDown("fast")}}});var m=b("<span/>").addClass("jquery-ui-switcher-title").appendTo(c);b("<span/>").addClass("jquery-ui-switcher-arrow").css({"float":"right",width:"16px",height:"16px",background:"url("+
-a.imgpath+"icon_color_arrow.gif) no-repeat 50% 50%"}).appendTo(c);if(b.cookie(a.cookiename))d(j(b.cookie(a.cookiename)));else a.loadtheme.length?d(j(a.loadtheme)):m.text(a.initialtext);var k=b("<div/>").addClass("jquery-ui-switcher-list-hldr").css({width:eval(a.width+8)+"px",background:"#000",color:"#FFF","font-family":"'Trebuchet MS', Verdana, sans-serif","font-size":"12px",border:"1px solid #CCC","border-top":"none","z-index":"999999",position:"absolute",top:eval(a.buttonheight+3)+"px",left:"0px",
-padding:"3px 3px 3px 0",display:"none"}).bind({mouseleave:function(){h()}});if(a.rounded){k.css("border-radius","0 0 6px 6px");k.css("-moz-border-radius","0 0 6px 6px");k.css("-webkit-border-radius","0 0 6px 6px")}var p=b("<ul/>").css({"list-style":"none",margin:"0",padding:"0","overflow-y":"auto","overflow-x":"hidden",height:a.height+"px"}).appendTo(k);b.each(l,function(f,e){var n=b("<li>").css("height","90px").appendTo(p),i=b("<a>").css({display:"block",padding:"5px 3px 5px 5px","text-decoration":"none",
-"float":"left",width:"100%",clear:"left"}).bind({mouseenter:function(){i.css("background","url("+a.imgpath+"menuhoverbg.png) repeat-x 50% 50%")},mouseleave:function(){i.css("background","none")},click:function(q){d(b(this).data());q.preventDefault()}}).attr("href","#").data(e).appendTo(n);b("<img>").attr("src",a.imgpath+e.icon).attr("title",e.title).css({"float":"left","margin-right":"5px",border:"1px solid #333"}).appendTo(i);b("<span>").css({"float":"left","padding-top":"5px",color:"#AAA"}).text(e.title).appendTo(i)});
-this.css("position","relative");this.append(c);this.append(k);return this}})(jQuery);
-jQuery.cookie=function(b,c,d){if(arguments.length>1&&String(c)!=="[object Object]"){d=jQuery.extend({},d);if(c===null||c===undefined)d.expires=-1;if(typeof d.expires==="number"){var j=d.expires,h=d.expires=new Date;h.setDate(h.getDate()+j)}c=String(c);return document.cookie=[encodeURIComponent(b),"=",d.raw?c:encodeURIComponent(c),d.expires?"; expires="+d.expires.toUTCString():"",d.path?"; path="+d.path:"",d.domain?"; domain="+d.domain:"",d.secure?"; secure":""].join("")}d=c||{};h=d.raw?function(g){return g}:
-decodeURIComponent;return(j=RegExp("(?:^|; )"+encodeURIComponent(b)+"=([^;]*)").exec(document.cookie))?h(j[1]):null};
+(function (b)
+{
+	b.fn.themeswitcher = function (c)
+	{
+		function d(f)
+		{
+			a.onselect !== null && a.onselect();
+			m.text(a.buttonpretext + " " + f.title);
+			var e = b("<link/>").attr("type", "text/css").attr("rel", "stylesheet");
+			if(f.url)
+			{
+				e.attr("href", f.url);
+				$.ajax({url:gs.xsltParams.library_name + "?a=g&rt=r&configChangeName=cssTheme&configChangeValue=" + f.url});
+			}
+			else
+			{
+				e.attr("href", "http://ajax.googleapis.com/ajax/libs/jqueryui/" + a.jqueryuiversion + "/themes/" + f.name + "/jquery-ui.css");
+				$.ajax({url:gs.xsltParams.library_name + "?a=g&rt=r&configChangeName=cssTheme&configChangeValue=" + "http://ajax.googleapis.com/ajax/libs/jqueryui/" + a.jqueryuiversion + "/themes/" + f.name + "/jquery-ui.css"});
+			}
+			e.appendTo("head");
+			b.cookie(a.cookiename, f.name);
+			g.find(".jquery-ui-switcher-title").text(a.buttonpretext + " " + f.title);
+			a.closeonselect && h()
+		}
+
+		function j(f)
+		{
+			var e = null;
+			b.each(l, function (n, i)
+			{
+				if (i.name.toLowerCase() === f.toLowerCase() || i.title.toLowerCase() === f.toLowerCase())
+				{
+					e = i;
+					return false
+				}
+			});
+			if (!e) return l[0];
+			return e
+		}
+
+		function h()
+		{
+			a.onclose !== null && a.onclose();
+			g.find(".jquery-ui-switcher-list-hldr").slideUp("fast", function ()
+			{
+				g.find(".jquery-ui-switcher-link").css(
+				{
+					color: "#666",
+					background: "#eee url(" + a.imgpath + "buttonbg.png) repeat-x 50% 50%"
+				})
+			})
+		}
+		var g = this,
+			o = {},
+			a = {
+				loadtheme: "",
+				height: 200,
+				width: 175,
+				rounded: true,
+				imgpath: "",
+				jqueryuiversion: "1.8.10",
+				initialtext: "Switch Theme",
+				buttonpretext: "Theme:",
+				closeonselect: true,
+				buttonheight: 14,
+				cookiename: "jquery-ui-theme",
+				themes: [],
+				additionalthemes: [],
+				onopen: null,
+				onclose: null,
+				onselect: null
+			};
+		if (c)
+		{
+			b.each(c, function (f, e)
+			{
+				o[f.toLowerCase()] = e
+			});
+			b.extend(a, o)
+		}
+		var l = a.themes.length ? a.themes : [
+		{
+			title: "Black Tie",
+			name: "black-tie",
+			icon: "theme_90_black_tie.png"
+		}, {
+			title: "Blitzer",
+			name: "blitzer",
+			icon: "theme_90_blitzer.png"
+		}, {
+			title: "Cupertino",
+			name: "cupertino",
+			icon: "theme_90_cupertino.png"
+		}, {
+			title: "Dark Hive",
+			name: "dark-hive",
+			icon: "theme_90_dark_hive.png"
+		}, {
+			title: "Dot Luv",
+			name: "dot-luv",
+			icon: "theme_90_dot_luv.png"
+		}, {
+			title: "Eggplant",
+			name: "eggplant",
+			icon: "theme_90_eggplant.png"
+		}, {
+			title: "Excite Bike",
+			name: "excite-bike",
+			icon: "theme_90_excite_bike.png"
+		}, {
+			title: "Flick",
+			name: "flick",
+			icon: "theme_90_flick.png"
+		}, {
+			title: "Hot Sneaks",
+			name: "hot-sneaks",
+			icon: "theme_90_hot_sneaks.png"
+		}, {
+			title: "Humanity",
+			name: "humanity",
+			icon: "theme_90_humanity.png"
+		}, {
+			title: "Le Frog",
+			name: "le-frog",
+			icon: "theme_90_le_frog.png"
+		}, {
+			title: "Mint Choc",
+			name: "mint-choc",
+			icon: "theme_90_mint_choco.png"
+		}, {
+			title: "Overcast",
+			name: "overcast",
+			icon: "theme_90_overcast.png"
+		}, {
+			title: "Pepper Grinder",
+			name: "pepper-grinder",
+			icon: "theme_90_pepper_grinder.png"
+		}, {
+			title: "Redmond",
+			name: "redmond",
+			icon: "theme_90_windoze.png"
+		}, {
+			title: "Smoothness",
+			name: "smoothness",
+			icon: "theme_90_smoothness.png"
+		}, {
+			title: "South Street",
+			name: "south-street",
+			icon: "theme_90_south_street.png"
+		}, {
+			title: "Start",
+			name: "start",
+			icon: "theme_90_start_menu.png"
+		}, {
+			title: "Sunny",
+			name: "sunny",
+			icon: "theme_90_sunny.png"
+		}, {
+			title: "Swanky Purse",
+			name: "swanky-purse",
+			icon: "theme_90_swanky_purse.png"
+		}, {
+			title: "Trontastic",
+			name: "trontastic",
+			icon: "theme_90_trontastic.png"
+		}, {
+			title: "UI Darkness",
+			name: "ui-darkness",
+			icon: "theme_90_ui_dark.png"
+		}, {
+			title: "UI Lightness",
+			name: "ui-lightness",
+			icon: "theme_90_ui_light.png"
+		}, {
+			title: "Vader",
+			name: "vader",
+			icon: "theme_90_black_matte.png"
+		}];
+		a.additionalthemes.length && b.extend(l, a.additionalthemes);
+		c = {
+			cursor: "pointer",
+			"font-family": "'Trebuchet MS', Verdana, sans-serif",
+			"font-size": "11px",
+			color: "#666",
+			background: "#eee url(" + a.imgpath + "buttonbg.png) repeat-x 50% 50%",
+			border: "1px solid #CCC",
+			"text-decoration": "none",
+			padding: "3px 3px 3px 8px",
+			width: a.width + "px",
+			display: "block",
+			height: a.buttonheight + "px",
+			outline: "0px",
+			"line-height": a.buttonheight + "px"
+		};
+		if (a.rounded)
+		{
+			c["border-radius"] = "6px";
+			c["-moz-border-radius"] = "6px";
+			c["-webkit-border-radius"] = "6px"
+		}
+		c = b("<a/>").addClass("jquery-ui-switcher-link").css(c).bind(
+		{
+			mouseenter: function ()
+			{
+				b(this).css(
+				{
+					background: "#eee"
+				})
+			},
+			mouseleave: function ()
+			{
+				g.find(".jquery-ui-switcher-list-hldr").is(":visible") || b(this).css(
+				{
+					background: "#eee url(" + a.imgpath + "buttonbg.png) repeat-x 50% 50%"
+				})
+			},
+			click: function ()
+			{
+				if (g.find(".jquery-ui-switcher-list-hldr").is(":visible")) h();
+				else
+				{
+					a.onopen !== null && a.onopen();
+					g.find(".jquery-ui-switcher-link").css(
+					{
+						color: "#AAA",
+						background: "#000"
+					});
+					g.find(".jquery-ui-switcher-list-hldr").slideDown("fast")
+				}
+			}
+		});
+		var m = b("<span/>").addClass("jquery-ui-switcher-title").appendTo(c);
+		b("<span/>").addClass("jquery-ui-switcher-arrow").css(
+		{
+			"float": "right",
+			width: "16px",
+			height: "16px",
+			background: "url(" + a.imgpath + "icon_color_arrow.gif) no-repeat 50% 50%"
+		}).appendTo(c);
+		if (b.cookie(a.cookiename)) d(j(b.cookie(a.cookiename)));
+		else a.loadtheme.length ? d(j(a.loadtheme)) : m.text(a.initialtext);
+		var k = b("<div/>").addClass("jquery-ui-switcher-list-hldr").css(
+		{
+			width: eval(a.width + 8) + "px",
+			background: "#000",
+			color: "#FFF",
+			"font-family": "'Trebuchet MS', Verdana, sans-serif",
+			"font-size": "12px",
+			border: "1px solid #CCC",
+			"border-top": "none",
+			"z-index": "999999",
+			position: "absolute",
+			top: eval(a.buttonheight + 3) + "px",
+			left: "0px",
+			padding: "3px 3px 3px 0",
+			display: "none"
+		}).bind(
+		{
+			mouseleave: function ()
+			{
+				h()
+			}
+		});
+		if (a.rounded)
+		{
+			k.css("border-radius", "0 0 6px 6px");
+			k.css("-moz-border-radius", "0 0 6px 6px");
+			k.css("-webkit-border-radius", "0 0 6px 6px")
+		}
+		var p = b("<ul/>").css(
+		{
+			"list-style": "none",
+			margin: "0",
+			padding: "0",
+			"overflow-y": "auto",
+			"overflow-x": "hidden",
+			height: a.height + "px"
+		}).appendTo(k);
+		b.each(l, function (f, e)
+		{
+			var n = b("<li>").css("height", "90px").appendTo(p),
+				i = b("<a>").css(
+				{
+					display: "block",
+					padding: "5px 3px 5px 5px",
+					"text-decoration": "none",
+					"float": "left",
+					width: "100%",
+					clear: "left"
+				}).bind(
+				{
+					mouseenter: function ()
+					{
+						i.css("background", "url(" + a.imgpath + "menuhoverbg.png) repeat-x 50% 50%")
+					},
+					mouseleave: function ()
+					{
+						i.css("background", "none")
+					},
+					click: function (q)
+					{
+						console.log(b(this).data());
+						d(b(this).data());
+						q.preventDefault()
+					}
+				}).attr("href", "#").data(e).appendTo(n);
+			b("<img>").attr("src", a.imgpath + e.icon).attr("title", e.title).css(
+			{
+				"float": "left",
+				"margin-right": "5px",
+				border: "1px solid #333"
+			}).appendTo(i);
+			b("<span>").css(
+			{
+				"float": "left",
+				"padding-top": "5px",
+				color: "#AAA"
+			}).text(e.title).appendTo(i)
+		});
+		this.css("position", "relative");
+		this.append(c);
+		this.append(k);
+		return this
+	}
+})(jQuery);
+jQuery.cookie = function (b, c, d)
+{
+	if (arguments.length > 1 && String(c) !== "[object Object]")
+	{
+		d = jQuery.extend(
+		{}, d);
+		if (c === null || c === undefined) d.expires = -1;
+		if (typeof d.expires === "number")
+		{
+			var j = d.expires,
+				h = d.expires = new Date;
+			h.setDate(h.getDate() + j)
+		}
+		c = String(c);
+		return document.cookie = [encodeURIComponent(b), "=", d.raw ? c : encodeURIComponent(c), d.expires ? "; expires=" + d.expires.toUTCString() : "", d.path ? "; path=" + d.path : "", d.domain ? "; domain=" + d.domain : "", d.secure ? "; secure" : ""].join("")
+	}
+	d = c || {};
+	h = d.raw ?
+	function (g)
+	{
+		return g
+	} : decodeURIComponent;
+	return (j = RegExp("(?:^|; )" + encodeURIComponent(b) + "=([^;]*)").exec(document.cookie)) ? h(j[1]) : null
+};
Index: /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/header.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/header.xsl	(revision 25122)
+++ /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/header.xsl	(revision 25123)
@@ -26,5 +26,13 @@
 	<xsl:template name="create-html-header">
 		<title><xsl:call-template name="pageTitle"/> :: <xsl:call-template name="siteName"/></title>
-		<link rel="stylesheet" href="interfaces/{$interface_name}/style/themes/main/jquery-ui-1.8.16.custom.css" type="text/css"/>
+		
+		<xsl:choose>
+			<xsl:when test="/page/pageResponse/interfaceOptions/option[@name = 'cssTheme']/@value">
+				<link rel="stylesheet" href="{/page/pageResponse/interfaceOptions/option[@name = 'cssTheme']/@value}" type="text/css"/>
+			</xsl:when>
+			<xsl:otherwise>
+				<link rel="stylesheet" href="interfaces/{$interface_name}/style/themes/main/jquery-ui-1.8.16.custom.css" type="text/css"/>
+			</xsl:otherwise>
+		</xsl:choose>
 		<link rel="stylesheet" href="interfaces/{$interface_name}/style/core.css" type="text/css"/>
 		<link rel="shortcut icon" href="favicon.ico"/> 
@@ -39,5 +47,5 @@
 			<xsl:call-template name="map-scripts"/>
 		</xsl:if>
-		<!--<xsl:call-template name="init-seaweed"/>-->
+		<xsl:call-template name="init-seaweed"/>
 		<xsl:call-template name="setup-gs-variable"/>
 		<xsl:call-template name="additionalHeaderContent"/>
@@ -54,11 +62,4 @@
 					try {
 						de.init();
-
-						de.doc.declarePropertySets({
-							metadata: {
-								phMarkup: '[Enter metadata value]',
-								name: "metadata"
-							}
-						});
 					}
 					catch (err) {
@@ -160,4 +161,5 @@
 
 				<!-- home -->
+				<!--
 				<li class="ui-state-default ui-corner-all">
 					<a href="{$library_name}?a=p&amp;amp;sa=home">
@@ -169,13 +171,34 @@
 					</a>
 				</li>
+				-->
 				
-				<!-- login -->
+				<!-- login/logout -->
 				<li class="ui-state-default ui-corner-all">
 					<xsl:choose>
-						<xsl:when test="/page/pageResponse/authenticationNode/service/@asn = '1'">
-							<a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.asn=&amp;s1.aup=Login">
+						<xsl:when test="/page/pageRequest/userInformation/@username">
+							<a>
+								<xsl:attribute name="href">
+									<xsl:value-of select="$library_name"/>
+									<xsl:text>?logout=</xsl:text>
+									<xsl:if test="/page/pageRequest/@action">
+										<xsl:text>&amp;a=</xsl:text>
+										<xsl:value-of select="/page/pageRequest/@action"/>
+									</xsl:if>
+									<xsl:if test="/page/pageRequest/@subaction">
+										<xsl:text>&amp;sa=</xsl:text>
+										<xsl:value-of select="/page/pageRequest/@subaction"/>
+									</xsl:if>
+									<xsl:for-each select="/page/pageRequest/paramList/param">
+										<xsl:if test="not(@name = 'username' or @name = 'password')">
+											<xsl:text>&amp;</xsl:text>
+											<xsl:value-of select="@name"/>
+											<xsl:text>=</xsl:text>
+											<xsl:value-of select="@value"/>
+										</xsl:if>
+									</xsl:for-each>
+								</xsl:attribute>
 								<xsl:attribute name="title"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'logout_tip')"/></xsl:attribute>
 								<ul>
-									<li><span><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'logout_b')"/></span></li>
+									<li><span><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'logout_b')"/><xsl:text> </xsl:text><xsl:value-of select="/page/pageRequest/userInformation/@username"/></span></li>
 									<li><span class="ui-icon ui-icon-unlocked"><xsl:text> </xsl:text></span></li>
 								</ul>
@@ -183,5 +206,25 @@
 						</xsl:when>
 						<xsl:otherwise>
-							<a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.asn=&amp;s1.aup=Login">
+							<a>
+								<xsl:attribute name="href">
+									<xsl:value-of select="$library_name"/>
+									<xsl:text>?a=p&amp;sa=login&amp;redirectURL=</xsl:text>
+									<xsl:value-of select="$library_name"/>
+									<xsl:text>%3F</xsl:text>
+									<xsl:if test="/page/pageRequest/@action">
+										<xsl:text>a=</xsl:text>
+										<xsl:value-of select="/page/pageRequest/@action"/>
+									</xsl:if>
+									<xsl:if test="/page/pageRequest/@subaction">
+										<xsl:text>%26sa=</xsl:text>
+										<xsl:value-of select="/page/pageRequest/@subaction"/>
+									</xsl:if>
+									<xsl:for-each select="/page/pageRequest/paramList/param">
+										<xsl:text>%26</xsl:text>
+										<xsl:value-of select="@name"/>
+										<xsl:text>=</xsl:text>
+										<xsl:value-of select="@value"/>
+									</xsl:for-each>
+								</xsl:attribute>
 								<xsl:attribute name="title"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'login_tip')"/></xsl:attribute>
 								<ul>
Index: /main/trunk/greenstone3/web/interfaces/oran/transform/pages/authen.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/transform/pages/authen.xsl	(revision 25122)
+++ /main/trunk/greenstone3/web/interfaces/oran/transform/pages/authen.xsl	(revision 25123)
@@ -293,5 +293,5 @@
 		<xsl:param name="pro_action"/>
 		<div>
-			<form id="LoginForm" method="get" action="{$library_name}">
+			<form id="LoginForm" method="post" action="{$library_name}">
 				<input type='hidden' name='a' value='g'/>
 				<input type='hidden' name='sa' value='{$sub_action}'/>
@@ -370,5 +370,5 @@
 					<td bgcolor="#eeeeee"><xsl:value-of select="@umc"/></td>
 					<td bgcolor="#eeeeee">
-						<form name="ListUsersForm" method="get" action="{$library_name}">
+						<form name="ListUsersForm" method="post" action="{$library_name}">
 							<input type='hidden' name='a' value='g'/>
 							<input type='hidden' name='sa' value='authen'/>
@@ -400,5 +400,5 @@
 		<xsl:param name="asn"/>
 		<div>
-			<form id="modifyForm" method="get" action="{$library_name}">
+			<form id="modifyForm" method="post" action="{$library_name}">
 				<input type='hidden' name='a' value='g'/>
 				<input type='hidden' name='sa' value='{$sub_action}'/>
@@ -435,5 +435,5 @@
 		<xsl:param name="asn"/>
 		<div>
-			<form id="deleteForm" method="get" action="{$library_name}">
+			<form id="deleteForm" method="post" action="{$library_name}">
 				<input type='hidden' name='a' value='g'/>
 				<input type='hidden' name='sa' value='{$sub_action}'/>
@@ -465,5 +465,5 @@
 		<xsl:param name="oumun_s"/>	
 		<xsl:param name="asn"/>
-			<form id="editForm" method="get" action="{$library_name}">
+			<form id="editForm" method="post" action="{$library_name}">
 				<input type='hidden' name='a' value='g'/>
 				<input type='hidden' name='sa' value='{$sub_action}'/>
Index: /main/trunk/greenstone3/web/interfaces/oran/transform/pages/login.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/transform/pages/login.xsl	(revision 25123)
+++ /main/trunk/greenstone3/web/interfaces/oran/transform/pages/login.xsl	(revision 25123)
@@ -0,0 +1,30 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+<xsl:stylesheet version="1.0"
+	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+	xmlns:java="http://xml.apache.org/xslt/java"
+	xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil"
+	xmlns:gslib="http://www.greenstone.org/skinning"
+	extension-element-prefixes="java util"
+	exclude-result-prefixes="java util">
+  
+	<!-- use the 'main' layout -->
+	<xsl:include href="layouts/main.xsl"/>
+
+	<!-- set page title -->
+	<xsl:template name="pageTitle"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'login_b')"/></xsl:template>
+
+	<!-- set page breadcrumbs -->
+	<xsl:template name="breadcrumbs"><gslib:siteLink/></xsl:template>
+
+	<!-- the page content -->
+	<xsl:template match="/page">
+		<div style="color:red;"><xsl:value-of select="/page/pageRequest/paramList/param[@name = 'loginMessage']/@value"/><xsl:text> </xsl:text></div>
+		<form method="post" action="{/page/pageRequest/paramList/param[@name = 'redirectURL']/@value}">
+			<table>
+				<tr><td>Username: </td><td><input type="text" name="username"/></td></tr>
+				<tr><td>Password: </td><td><input type="password" name="password"/></td></tr>
+				<tr><td><input type="submit" value="Login"/></td><td><xsl:text> </xsl:text></td></tr>
+			</table>
+		</form>
+	</xsl:template>
+</xsl:stylesheet>
Index: /main/trunk/greenstone3/web/interfaces/oran/transform/pages/pref.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/transform/pages/pref.xsl	(revision 25122)
+++ /main/trunk/greenstone3/web/interfaces/oran/transform/pages/pref.xsl	(revision 25123)
@@ -208,5 +208,5 @@
 				
 				<!-- Theme Changer -->
-				<xsl:if test="/page/pageResponse/authenticationNode/service/@asn = '1' and util:contains(/page/pageResponse/authenticationNode/service/@umgp, 'administrator')">
+				<xsl:if test="/page/pageRequest/userInformation and util:contains(/page/pageRequest/userInformation/@groups, 'administrator')">
 					<script type="text/javascript">
 						<xsl:text disable-output-escaping="yes">