Index: main/trunk/greenstone3/build.xml
===================================================================
--- main/trunk/greenstone3/build.xml	(revision 25095)
+++ main/trunk/greenstone3/build.xml	(revision 25131)
@@ -83,9 +83,9 @@
   <!-- version properties for external packages -->
   <!-- for Java versions < 1.4, we print out the message that Java is too old.
-	For Java 1.4, we use Tomcat 5.5, for Java5 and higher, we use Tomcat 6.0-->
-  <condition property="tomcat.version" value="apache-tomcat-5.5.25" else="apache-tomcat-6.0.20"> 
+	For Java 1.4, we use Tomcat 5.5, for Java5 and higher, we use Tomcat 7.0-->
+  <condition property="tomcat.version" value="apache-tomcat-5.5.25" else="apache-tomcat-7.0.26"> 
     <equals arg1="1.4" arg2="${ant.java.version}"/>
   </condition>
-  <condition property="tomcat.version.major" value="5" else="6"> 
+  <condition property="tomcat.version.major" value="5" else="7"> 
     <equals arg1="1.4" arg2="${ant.java.version}"/>
   </condition>
@@ -145,5 +145,5 @@
     </and>
   </condition>
-  
+ 
   <property name="os.linux" value="Linux"/> 
   <property name="os.mac" value="Mac OS X"/>
@@ -442,6 +442,6 @@
   </path>
   
-  <!-- All elements that Tomcat 6 exposes to applications -->
-  <path id="tomcat6">
+  <!-- All elements that Tomcat 7 exposes to applications -->
+  <path id="tomcat7">
     <fileset dir="${catalina.home}/lib">
       <include name="*.jar"/>
@@ -731,5 +731,5 @@
     <!--
     the next block checks if the bundled tomcat is present in the 'packages' directory,
-    and checks for the lethal combination of tomcat 6 and java 1.4. Test for
+    and checks for the lethal combination of tomcat 7 and java 1.4. Test for
     tomcat6 is based on the presence of a file inserted by greenstone into the tomcat6
     download, as there is no other surefire way to check tomcat version under java 1.4
@@ -738,6 +738,6 @@
       <available file="packages/tomcat"/>
     </condition>
-    <condition property="packages.tomcat.istomcat6" value="true" else="false">
-      <available file="packages/tomcat/tomcat6.txt"/>
+    <condition property="packages.tomcat.istomcat7" value="true" else="false">
+      <available file="packages/tomcat/tomcat7.txt"/>
     </condition>
     <if>
@@ -745,5 +745,5 @@
         <and>
           <istrue value="${packages.tomcat.ispresent}"/>
-          <istrue value="${packages.tomcat.istomcat6}"/>
+          <istrue value="${packages.tomcat.istomcat7}"/>
           <equals arg1="1.4" arg2="${ant.java.version}"/>
         </and>
@@ -955,8 +955,8 @@
   
   <!-- this target downloads and installs Tomcat -->
-  <!-- we download tomcat (version 6 for Java 1.5 and later, version 5 for Java 1.4 plus the 1.4 compatibility package). -->
+  <!-- we download tomcat (version 7 for Java 1.5 and later, version 5 for Java 1.4 plus the 1.4 compatibility package). -->
   <target name="prepare-tomcat" depends="init,setup-proxy" if="tomcat.islocal"
-    description="downloads the appropriate version of Tomcat (Tomcat 5 if using Java 1.4, Tomcat 6 if using Java 1.5 or higher). If you want to change which version of Java you are using between 1.4 and 1.5/6 then you need to run prepare-tomcat">
-    <if>
+    description="downloads the appropriate version of Tomcat (Tomcat 5 if using Java 1.4, Tomcat 7 if using Java 1.5 or higher). If you want to change which version of Java you are using between 1.4 and 1.5/7 then you need to run prepare-tomcat">
+  <if>
       <bool>
         <not><available file="${packages.home}/tomcat/.flagfile"/></not>
@@ -987,4 +987,5 @@
         <fileset dir="${packages.home}/${tomcat.version}"/>
       </move>
+	  
       <copy file="${basedir}/resources/tomcat/setclasspath.bat"
         tofile="${packages.home}/tomcat/bin/setclasspath.bat"
@@ -993,4 +994,5 @@
         tofile="${packages.home}/tomcat/bin/setclasspath.sh"
         overwrite="true"/>
+
       <!-- make sure we have execute permission for the .sh files -->
       <chmod dir="${packages.home}/tomcat/bin" perm="ugo+rx" 
@@ -1346,4 +1348,5 @@
     description="Compile only the Greenstone core">
     <mkdir dir="${build.home}"/>
+	
     <if><bool><isset property="with.jni"/></bool>
 	<javac srcdir="${src.home}"