Index: in/trunk/greenstone2/runtime-src/src/corba/corbaiface_skel.mpp
===================================================================
--- /main/trunk/greenstone2/runtime-src/src/corba/corbaiface_skel.mpp	(revision 25229)
+++ 	(revision )
@@ -1,274 +1,0 @@
-/*
- *  MICO --- a free CORBA implementation
- *  Copyright (C) 1997-98 Kay Roemer & Arno Puder
- *
- *  This file was automatically generated. DO NOT EDIT!
- */
-#include "corbaiface.h"
-
-//--------------------------------------------------------
-//  Implementation of skeletons
-//--------------------------------------------------------
-
-gsdlInterface::corbaiface_skel::corbaiface_skel( const CORBA::BOA::ReferenceData &_id )
-{
-  CORBA::ImplementationDef_var _impl =
-    _find_impl( "IDL:gsdlInterface/corbaiface:1.0", "corbaiface" );
-  assert( !CORBA::is_nil( _impl ) );
-  _create_ref( _id,
-    0,
-    _impl,
-    "IDL:gsdlInterface/corbaiface:1.0" );
-  register_dispatcher( new StaticInterfaceDispatcherWrapper<corbaiface_skel>( this ) );
-}
-
-gsdlInterface::corbaiface_skel::corbaiface_skel( CORBA::Object_ptr _obj )
-{
-  CORBA::ImplementationDef_var _impl =
-    _find_impl( "IDL:gsdlInterface/corbaiface:1.0", "corbaiface" );
-  assert( !CORBA::is_nil( _impl ) );
-  _restore_ref( _obj,
-    CORBA::BOA::ReferenceData(),
-    0,
-    _impl );
-  register_dispatcher( new StaticInterfaceDispatcherWrapper<corbaiface_skel>( this ) );
-}
-
-gsdlInterface::corbaiface_skel::~corbaiface_skel()
-{
-}
-
-bool gsdlInterface::corbaiface_skel::dispatch( CORBA::StaticServerRequest_ptr _req, CORBA::Environment & /*_env*/ )
-{
-  #ifdef HAVE_EXCEPTIONS
-  try {
-  #endif
-    switch (mico_string_hash (_req->op_name(), 17)) {
-    case 0:
-      if( strcmp( _req->op_name(), "collectionList" ) == 0 ) {
-        corbatext_tarray collist;
-        CORBA::StaticAny _collist( _marshaller__seq_gsdlInterface_corbatext_t, &collist );
-        corbaComError error;
-        CORBA::StaticAny _error( _marshaller_gsdlInterface_corbaComError, &error );
-
-        _req->add_inout_arg( &_collist );
-        _req->add_inout_arg( &_error );
-
-        if( !_req->read_args() )
-          return true;
-
-        collectionList( collist, error );
-        _req->write_results();
-        return true;
-      }
-      break;
-    case 3:
-      if( strcmp( _req->op_name(), "ping" ) == 0 ) {
-        corbatext_t collection;
-        CORBA::StaticAny _collection( _marshaller_gsdlInterface_corbatext_t, &collection );
-        CORBA::Boolean wasSuccess;
-        CORBA::StaticAny _wasSuccess( CORBA::_stc_boolean, &wasSuccess );
-        corbaComError error;
-        CORBA::StaticAny _error( _marshaller_gsdlInterface_corbaComError, &error );
-
-        _req->add_in_arg( &_collection );
-        _req->add_inout_arg( &_wasSuccess );
-        _req->add_inout_arg( &_error );
-
-        if( !_req->read_args() )
-          return true;
-
-        ping( collection, wasSuccess, error );
-        _req->write_results();
-        return true;
-      }
-      break;
-    case 7:
-      if( strcmp( _req->op_name(), "filter" ) == 0 ) {
-        corbatext_t collection;
-        CORBA::StaticAny _collection( _marshaller_gsdlInterface_corbatext_t, &collection );
-        corbaFilterRequest request;
-        CORBA::StaticAny _request( _marshaller_gsdlInterface_corbaFilterRequest, &request );
-        corbaFilterResponse response;
-        CORBA::StaticAny _response( _marshaller_gsdlInterface_corbaFilterResponse, &response );
-        corbaComError error;
-        CORBA::StaticAny _error( _marshaller_gsdlInterface_corbaComError, &error );
-
-        _req->add_in_arg( &_collection );
-        _req->add_in_arg( &_request );
-        _req->add_inout_arg( &_response );
-        _req->add_inout_arg( &_error );
-
-        if( !_req->read_args() )
-          return true;
-
-        filter( collection, request, response, error );
-        _req->write_results();
-        return true;
-      }
-      break;
-    case 9:
-      if( strcmp( _req->op_name(), "getFilterOptions" ) == 0 ) {
-        corbatext_t collection;
-        CORBA::StaticAny _collection( _marshaller_gsdlInterface_corbatext_t, &collection );
-        corbatext_t option;
-        CORBA::StaticAny _option( _marshaller_gsdlInterface_corbatext_t, &option );
-        corbaFilterOptionsResponse response;
-        CORBA::StaticAny _response( _marshaller_gsdlInterface_corbaFilterOptionsResponse, &response );
-        corbaComError error;
-        CORBA::StaticAny _error( _marshaller_gsdlInterface_corbaComError, &error );
-
-        _req->add_in_arg( &_collection );
-        _req->add_in_arg( &_option );
-        _req->add_inout_arg( &_response );
-        _req->add_inout_arg( &_error );
-
-        if( !_req->read_args() )
-          return true;
-
-        getFilterOptions( collection, option, response, error );
-        _req->write_results();
-        return true;
-      }
-      break;
-    case 10:
-      if( strcmp( _req->op_name(), "getCollectInfo" ) == 0 ) {
-        corbatext_t collection;
-        CORBA::StaticAny _collection( _marshaller_gsdlInterface_corbatext_t, &collection );
-        corbaColInfoResponse response;
-        CORBA::StaticAny _response( _marshaller_gsdlInterface_corbaColInfoResponse, &response );
-        corbaComError error;
-        CORBA::StaticAny _error( _marshaller_gsdlInterface_corbaComError, &error );
-
-        _req->add_in_arg( &_collection );
-        _req->add_inout_arg( &_response );
-        _req->add_inout_arg( &_error );
-
-        if( !_req->read_args() )
-          return true;
-
-        getCollectInfo( collection, response, error );
-        _req->write_results();
-        return true;
-      }
-      break;
-    case 11:
-      if( strcmp( _req->op_name(), "initialise" ) == 0 ) {
-        corbaComError error;
-        CORBA::StaticAny _error( _marshaller_gsdlInterface_corbaComError, &error );
-
-        CORBA::Boolean _res;
-        CORBA::StaticAny __res( CORBA::_stc_boolean, &_res );
-        _req->add_inout_arg( &_error );
-        _req->set_result( &__res );
-
-        if( !_req->read_args() )
-          return true;
-
-        _res = initialise( error );
-        _req->write_results();
-        return true;
-      }
-      if( strcmp( _req->op_name(), "getFilterInfo" ) == 0 ) {
-        corbatext_t collection;
-        CORBA::StaticAny _collection( _marshaller_gsdlInterface_corbatext_t, &collection );
-        corbatext_tarray filterNames;
-        CORBA::StaticAny _filterNames( _marshaller__seq_gsdlInterface_corbatext_t, &filterNames );
-        corbaComError error;
-        CORBA::StaticAny _error( _marshaller_gsdlInterface_corbaComError, &error );
-
-        _req->add_in_arg( &_collection );
-        _req->add_inout_arg( &_filterNames );
-        _req->add_inout_arg( &_error );
-
-        if( !_req->read_args() )
-          return true;
-
-        getFilterInfo( collection, filterNames, error );
-        _req->write_results();
-        return true;
-      }
-      break;
-    case 12:
-      if( strcmp( _req->op_name(), "hasCollection" ) == 0 ) {
-        corbatext_t corbaCollection;
-        CORBA::StaticAny _corbaCollection( _marshaller_gsdlInterface_corbatext_t, &corbaCollection );
-        CORBA::Boolean has;
-        CORBA::StaticAny _has( CORBA::_stc_boolean, &has );
-        corbaComError error;
-        CORBA::StaticAny _error( _marshaller_gsdlInterface_corbaComError, &error );
-
-        _req->add_in_arg( &_corbaCollection );
-        _req->add_inout_arg( &_has );
-        _req->add_inout_arg( &_error );
-
-        if( !_req->read_args() )
-          return true;
-
-        hasCollection( corbaCollection, has, error );
-        _req->write_results();
-        return true;
-      }
-      break;
-    case 13:
-      if( strcmp( _req->op_name(), "configure" ) == 0 ) {
-        corbatext_t key;
-        CORBA::StaticAny _key( _marshaller_gsdlInterface_corbatext_t, &key );
-        corbatext_tarray cfgline;
-        CORBA::StaticAny _cfgline( _marshaller__seq_gsdlInterface_corbatext_t, &cfgline );
-        corbaComError error;
-        CORBA::StaticAny _error( _marshaller_gsdlInterface_corbaComError, &error );
-
-        _req->add_in_arg( &_key );
-        _req->add_in_arg( &_cfgline );
-        _req->add_inout_arg( &_error );
-
-        if( !_req->read_args() )
-          return true;
-
-        configure( key, cfgline, error );
-        _req->write_results();
-        return true;
-      }
-      if( strcmp( _req->op_name(), "getDocument" ) == 0 ) {
-        corbatext_t collection;
-        CORBA::StaticAny _collection( _marshaller_gsdlInterface_corbatext_t, &collection );
-        corbaDocRequest request;
-        CORBA::StaticAny _request( _marshaller_gsdlInterface_corbaDocRequest, &request );
-        corbaDocResponse response;
-        CORBA::StaticAny _response( _marshaller_gsdlInterface_corbaDocResponse, &response );
-        corbaComError error;
-        CORBA::StaticAny _error( _marshaller_gsdlInterface_corbaComError, &error );
-
-        _req->add_in_arg( &_collection );
-        _req->add_inout_arg( &_request );
-        _req->add_inout_arg( &_response );
-        _req->add_inout_arg( &_error );
-
-        if( !_req->read_args() )
-          return true;
-
-        getDocument( collection, request, response, error );
-        _req->write_results();
-        return true;
-      }
-      break;
-    }
-  #ifdef HAVE_EXCEPTIONS
-  } catch( CORBA::SystemException_catch &_ex ) {
-    _req->set_exception( _ex->_clone() );
-    _req->write_results();
-    return true;
-  } catch( ... ) {
-    assert( 0 );
-    return true;
-  }
-  #endif
-  return false;
-}
-
-gsdlInterface::corbaiface_ptr gsdlInterface::corbaiface_skel::_this()
-{
-  return gsdlInterface::corbaiface::_duplicate( this );
-}
-